from allure.allure import error_message
from helper.echo import echo, ECHO_COLORS


def event_wrapper(**kwargs):
    def inner(function):
        def wrapper(*args):
            data = _generate_data(args)
            result = function(*args)
            color = ECHO_COLORS.OKGREEN if result else ECHO_COLORS.FAIL
            color = ECHO_COLORS.WARNING if kwargs['method_name'] == 'wait element' else color
            echo('[Data: %s] [Method: %s] [Result: %s]' % (data, kwargs['method_name'], result), color=color)
            _hard_assert_true(kwargs['method_name'], result, args)
            return result
        return wrapper
    return inner


def _hard_assert_true(method_name: str, result: bool, args):
    if method_name in ['exists', 'not exists', 'wait'] and result is False:
        msg = 'Method name - "%s". Element - "%s". Expected result True, but Real - False.' \
              % (method_name, args[1].description)
        echo(msg, color=ECHO_COLORS.FAIL)
        error_message(msg, args[0])
        assert result, msg


def _generate_data(*args):
    if len(args) == 0:
        return 'empty'
    items = ''
    for item in args[0]:
        if item is not None:
            items += '%s; ' % str(item)
    return items[:-1]
